package org.nakedobjects.nof.core.reflect;

public class Veto extends AbstractConsent {
    private static final long serialVersionUID = 1L;
    
    /**
     * An Veto object with no reason.
     */
    public final static Veto DEFAULT = new Veto();

    public Veto() {
        super();
    }

    public Veto(final String reason) {
        super(reason);
    }

    public Veto(final RuntimeException exception) {
        super(exception);
    }

    /**
     * Returns false.
     */
    public final boolean isAllowed() {
        return false;
    }

    /**
     * Returns true.
     */
    public final boolean isVetoed() {
        return true;
    }
}
// Copyright (c) Naked Objects Group Ltd.
